<template>
  <div class="form-wrap">
    <!--渲染不同的模块表单-->
    <div  v-if="canRender" v-for="(item, index) in addComponents">
      <div v-if="item.showModule" class="content-box" >
        <div v-if="!item.hideTitle" class="title">{{item.title}}</div>
        <el-form
          :ref="'form' + index"
          :id="'form' + index"
          :model="item.formObject"
          size="medium"
          label-position="left"
          class="form"
        >
          <FormScale
            :dataSource="item.dataSource"
            :form="item.formObject"
            :ruleNew="item.ruleNew"
            :class="item.className"
          />
        </el-form>
      </div>
    </div>
  </div>
</template>

<script>
  import { getDomain, getScaleModels, getScaleDetail, postScale, updateScalesStatus, submitScale  } from '@/utils/followup/followapis'

  // 量表 template
  import FormScale from '@/components/followup/form/index'

  // 量表模块数据模型

  // 高血压
  import hypeDataSourceBaseInfo from '../models/hypertension/hypeDataSourceBaseInfo'
  import hypeDataSourceSymptom from '../models/hypertension/hypeDataSourceSymptom'
  import hypeDataSourceSign from '../models/hypertension/hypeDataSourceSign'
  import hypeDataSourceLifeMode from '../models/hypertension/hypeDataSourceLifeMode'
  import hypeDataSourceHelpChecking from '../models/hypertension/hypeDataSourceHelpChecking'
  import hypeDataSourceMedicationUse from '../models/hypertension/hypeDataSourceMedicationUse'
  import hypeDataSourceReferral from '../models/hypertension/hypeDataSourceReferral'
  import hypeDataSourceNextFollowDay from '../models/hypertension/hypeDataSourceNextFollowDay'

  export default {
    data(){
      return {
        domain: '',//通过接口获取白名单域名
        needRule: true, //是否动态开启验证
        showModule: true, //是否隐藏表单模块
        canRender: true,
        valid: false,
        validList: [],
        moduleList: [],//模块列表
        planPatientsTimesId: '',
        scaleNo: '',
        doctorId: '',
        planTimesId: '',
        addComponents: [],
        addComponentsSourceList: [],
        formData: {},//整个表单对象
      }
    },
    components: {
      FormScale,
    },
    props: {
      scaleType: String,//病种类型
      checkStart: Boolean,
      saveWay: Number,
      showBtn: String,
    },
    watch: {
      checkStart(val){
        if(val){
          this.validList = [];
          for(let i=0;i<this.addComponents.length;i++){
            let formName = this.addComponents[i].formName;
            // 将每个模块的fornName对应后台的表名放到表单对象
            this.formData[formName] = this.addComponents[i].formObject;

//            if(formName==='stroke_006'||formName==='stroke_014'||formName==='stroke_015'){
//              this.setRuleToTrue(i)
//            }
            this.$nextTick(()=>{
              // saveWay=1是提交，进行校验，2是暂存，不需要校验，直接发送请求
              if(this.saveWay==1){
                if(this.$refs['form' + i].length > 0){
                  this.$refs['form' + i][0].validate((valid) => {
                    this.validList.push(valid);
                  });
                }
              }
            })
          }

          this.$nextTick(()=>{
            // saveWay=1是提交，进行校验，2是暂存，不需要校验，直接发送请求
            if(this.saveWay==1){
              for(let k=0;k<this.validList.length;k++){
                if(!this.validList[k]){
                  this.$emit('checkEnd',false);
                  this.valid = false;
                  this.$nextTick(() => {
                    // 如果表单未完善，跳转到该表单模块
                    document.querySelector(`#form${k}`).scrollIntoView(true);
                  })
                  return;
                }else{
                  this.valid = true;
                }
              }
              if(this.valid){
                this.dataSubmit(()=>{
                  updateScalesStatus({
                    fuPlanPatientTimesId: this.planPatientsTimesId,
                    planTimesId: this.planTimesId,
                    resourceId: this.scaleNo
                  })
                });
              }
            }else{
              this.dataSubmit();
            }

            this.$emit('checkEnd',false);

          })

        }else{
          this.$emit('checkEnd',false);
        }
      },
      showModule(val){
        this.addComponents.forEach((item,index)=>{
          if(index >= 3){
            this.addComponents[index].showModule = val;
          }
        })
      },
//      needRule(val){
//        this.addComponents.forEach((item,index)=>{
//          let formName = item.formName;
////          if(formName==='stroke_006'||formName==='stroke_014'||formName==='stroke_015'){
////            this.addComponents[index].ruleNew = val;
////            this.setRuleToTrue(index);
//////            if(this.$refs['form' + index].length > 0){
//////              this.$refs['form' + index][0].resetFields();
//////            }
////
////          }
//        })
//
//      }
    },
    created(){
      this.planPatientsTimesId = this.$route.query.planPatientsTimesId
      this.scaleNo = this.$route.query.scaleNo
      this.doctorId = this.$route.query.doctorId
      this.planTimesId = this.$route.query.planTimesId;
      // 获取量表类型
      this.initScaleType();
      // 获取白名单域名
      this.getWhiteDomain();

//      localStorage.setItem('needRule',this.needRule);
    },
    methods: {
      // 获取量表类型
      initScaleType(){
        this.addComponentsSourceList = [
          {name: 'hypeDataSourceBaseInfo',formObject: {},showModule: true,formName: 'hypertension_001',className: 'obj-form-title',dataSource: hypeDataSourceBaseInfo(this), hideTitle: true, title: '基本信息'},
          {name: 'hypeDataSourceSymptom',formObject: {},showModule: true,formName: 'hypertension_002',className: 'obj-form-title',dataSource: hypeDataSourceSymptom(this), hideTitle: false, title: '症状'},
          {name: 'hypeDataSourceSign',formObject: {bmi: 0,},showModule: true,formName: 'hypertension_003',className: 'obj-form-title',dataSource: hypeDataSourceSign(this), hideTitle: false, title: '体征'},
          {name: 'hypeDataSourceLifeMode',formObject: {},showModule: true,formName: 'hypertension_004',className: 'obj-form-title',dataSource: hypeDataSourceLifeMode(this), hideTitle: false, title: '生活方式指导'},
          {name: 'hypeDataSourceHelpChecking',formObject: {},showModule: true,formName: 'hypertension_005',className: 'obj-form-title',dataSource: hypeDataSourceHelpChecking(this), hideTitle: false, title: '辅助检查'},
          {name: 'hypeDataSourceMedicationUse',formObject: {},showModule: true,formName: 'hypertension_006',className: 'obj-form-title',dataSource: hypeDataSourceMedicationUse(this), hideTitle: false, title: '用药情况'},
          {name: 'hypeDataSourceReferral',formObject: {reason:'',mechanismDepartment:''},showModule: true,formName: 'hypertension_007',className: 'obj-form-title',dataSource: hypeDataSourceReferral(this), hideTitle: false, title: '转诊'},
          {name: 'hypeDataSourceNextFollowDay',formObject: {nextFollowDay:''},showModule: true,formName: 'hypertension_008',className: 'obj-form-title',dataSource: hypeDataSourceNextFollowDay(this), hideTitle: true, title: '下次随访日期'},
        ]
      },
      // 获取白名单域名
      getWhiteDomain(){
        getDomain().then(res=>{
          if(res.code=='000000'){
            this.domain = res.data;
            this.setFormData()

            // 目前模块先写死！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！
              // 获取量表模块
//              this.getFormModules();
//              if(this.showBtn!='0'){
//                // 获取量表详情
//                this.getFormDetail();
//              }
          }else{
            this.$message({
              message: res.message,
              type: 'error'
            });
          }
        })
      },
      // 目前先默认写死
      setFormData(){
        this.addComponents = this.addComponentsSourceList
        for(let i=0;i<this.addComponents.length;i++){
          let formName = this.addComponents[i].formName;

          if(this.formData[formName]){

            this.addComponents[i].formObject = this.formData[formName];
          }
          // 量表字段回显，会触发change校验，所以这里拿到数据渲染页面后，重置验证
//          if(this.$refs['form' + i].length > 0){
//            this.$refs['form' + i][0].resetFields();
//          }
        }
        this.canRender = true;
        this.$forceUpdate();
      },

      // 动态开启验证开关
//      setRuleToTrue(index){
//        this.addComponents[index].dataSource.forEach((item,k)=>{
//          if(item.rules && item.rules.length > 0){
//            if(!this.needRule){
//              this.addComponents[index].dataSource[k].rules[0].required = true;
//            }else{
//              this.addComponents[index].dataSource[k].rules[0].required = false;
//            }
//          }
//        })
//      },
      // 获取展示的模块
      getFormModules(){
        getScaleModels(this.domain,this.scaleNo).then(res=>{
          if(res.code=='000000'){
            this.moduleList = res.data;
            for(let i=0;i<this.moduleList.length;i++){
              for(let j=0;j<this.addComponentsSourceList.length;j++){
                if(this.moduleList[i]==this.addComponentsSourceList[j].formName){
                  this.addComponents.push(this.addComponentsSourceList[j])
                }
              }
            }
          }else{
            this.$message({
              message: res.message,
              type: 'error'
            });
          }
        })
      },
      // 获取量表详情
      getFormDetail(){
        getScaleDetail(this.domain,this.planPatientsTimesId,this.scaleNo).then(res=>{
          this.formData = res.data
          let keysList = Object.keys(this.formData);
          if(keysList.length > 0){
            for(let i=0;i<this.addComponents.length;i++){
              let formName = this.addComponents[i].formName;

              if(this.formData[formName]){
                let investigationState = this.formData[formName].investigationState;
                let inTurn = this.formData[formName].inTurn;
                if( ( investigationState === '失访' || investigationState === '死亡' ) ){
                  this.showModule = false;
                }
//                if(inTurn == '12个月'){
//                  this.needRule = false;
//                }

                this.addComponents[i].formObject = this.formData[formName];
//                if(formName=='hypertension_001'){
//                  this.addComponents[i].formObject.dyslipidemia = []
//                }
              }
              // 量表字段回显，会触发change校验，所以这里拿到数据渲染页面后，重置验证
              if(this.$refs['form' + i].length > 0){
                this.$refs['form' + i][0].resetFields();
              }
            }
            this.canRender = true;
            this.$forceUpdate();
          }
        })
      },
      // 提交量表
      dataSubmit(callback){
//        if(this.valid){
        // console.log(this.formData)
        this.formData.doctorId = parseFloat(this.doctorId);
        this.formData.saveWay = parseFloat(this.saveWay);
        this.formData.planPatientsTimesId = parseFloat(this.planPatientsTimesId);
        this.formData.scaleNo = this.scaleNo;
        this.formData.isLine = 2;
        // console.log(JSON.stringify(this.formData))
        postScale(this.domain,this.formData).then(res=>{
          if(res.code=='000000'){
            let doMsg = (this.saveWay==1) ? '提交成功' : '保存成功';
            this.$message({
              message: doMsg,
              type: 'success'
            });
            if(callback){
              callback();
            }
            setTimeout(()=>{
              this.$router.push({
                path: '/followup/record-manage/record-list'
              })
            },1000)
          }else{
            let doMsg = (this.saveWay==1) ? '提交失败' : '保存失败';
            this.$message({
              message: doMsg,
              type: 'error'
            });
          }
        });
//        }
//        this.$emit('checkEnd',false);
      },
    },
  }
</script>

<style scoped lang="scss">
  .form-wrap{
    .content-box{
      .title{
        line-height: 60px;
        height: 60px;
        font-weight: bold;
        font-size: 22px;
        border-bottom: 1px dashed #ccc;
      }
    }
  }
</style>
